﻿Imports System.Runtime.CompilerServices
Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: Diese Codezeile lädt Daten in die Tabelle "Database1DataSet1.tool". Sie können sie bei Bedarf verschieben oder entfernen.
        Me.ToolTableAdapter.Fill(Me.Database1DataSet1.tool)
        'TODO: Diese Codezeile lädt Daten in die Tabelle "Database1DataSet.personal". Sie können sie bei Bedarf verschieben oder entfernen.
        Me.PersonalTableAdapter.Fill(Me.Database1DataSet.personal)
        'TODO: Diese Codezeile lädt Daten in die Tabelle "Database1DataSet.matrix". Sie können sie bei Bedarf verschieben oder entfernen.
        Me.MatrixTableAdapter.Fill(Me.Database1DataSet.matrix)

    End Sub

    Private Sub btn_Click(sender As Object, e As EventArgs) Handles btnFilterPersonal.Click,
                                                                    btnFilterTool.Click,
                                                                    btnResetFilter.Click
        Select Case True
            Case sender Is btnFilterPersonal : bsMatrix.FilterX("personal_id = ?", 1)
            Case sender Is btnFilterTool : bsMatrix.FilterX("tool_id = ?", 2)
            Case sender Is btnResetFilter : bsMatrix.Filter = ""
        End Select
    End Sub

End Class

Public Module BsFilter

    ''' <summary>
    ''' provides a placeholder-syntax for filters. Sample: dv.FilterX("Datum >= ? And ? >= Datum", dtpVon.Value, dtpBis.Value)
    ''' </summary>
    ''' <exception cref="ArgumentException">expression contains more placeholders than values are passed</exception>
    <Extension()>
    Public Sub FilterX(bs As BindingSource, expression As String, ParamArray values() As Object)
        bs.Filter = GetFilterString(expression, values)
    End Sub
    ''' <summary> Get the FilterX()-FilterString for Debugging </summary>
    <Extension()>
    Public Function GetFilterString(bs As BindingSource, expression As String, ParamArray values() As Object) As String
        Return GetFilterString(expression, values)
    End Function

    Public Function GetFilterString(expression As String, values() As Object) As String
        Dim segments = expression.Split("?"c)      ' identify placeholder '?'
        If segments.Count > values.Length + 1 Then Throw New ArgumentException(
            "expression contains more placeholders than values are passed")
        For i = 0 To segments.Length - 2
            Dim val = values(i)
            Dim sb = New Text.StringBuilder("{0}")
            If TypeOf val Is Date Then
                sb.Insert(0, "#"c).Append("#"c)
            ElseIf TypeOf val Is String Then
                With segments(i)                    ' identify LIKE - wildcard '*' or '%' at end of segement
                    If "*%".Contains(.Chars(.Length - 1)) Then sb.Insert(0, "*"c) : segments(i) = .Remove(.Length - 1, 1)
                End With
                With segments(i + 1)       ' identify wildcard '*' or '%'
                    If .Length > 0 AndAlso "*%".Contains(.Chars(0)) Then sb.Append("*"c) : segments(i + 1) = .Remove(0, 1)
                End With
                sb.Insert(0, "'"c).Append("'"c)
            End If
            segments(i) &= String.Format(Globalization.CultureInfo.InvariantCulture, sb.ToString, val)
        Next
        Return String.Concat(segments)
    End Function

End Module
